import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Desk here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Desk  extends Mover
{

    private boolean foundTarget = false;
    private static final int DAMAGE_TO_BOSS=10;
    private static final int AREA=12;
    private static final int AREA_FOR_BOSS=22;
    private static final int SPEED=8;
    public Desk(Vector speed)
    {
        super(speed);
        setSpeed(new Vector(180, SPEED));
        //Greenfoot.playSound("EnergyGun.wav");
    }
    
    public void act(){
        if(this.getX() <= 7) {
            getWorld().removeObject(this);
        }else {
            move();
            theMatIntersection();
            theCopIntersection();
            theBossIntersection();
        }
    }   
    
    /**
     * Check if intersects with the Boss.
     */
    public void theBossIntersection(){
        if(!foundTarget){
            Pig pig = (Pig)getOneIntersectingObject(Pig.class);
            if(pig!=null){
                foundTarget = true;
                
                if(pig.getY()-this.getY()>0 && pig.getY()-this.getY()<AREA_FOR_BOSS){
                    getWorld().removeObject(this);
                    pig.hit(DAMAGE_TO_BOSS);
                    
                }else if(pig.getY()-this.getY()>= AREA_FOR_BOSS){
                    getWorld().setPaintOrder(pig.getClass(), this.getClass());
                    
                }else{
                    getWorld().setPaintOrder(this.getClass(), pig.getClass());
                }
            }
        }
    }    /**
     * Check if intersects with a cop.
     */ 
    public void theCopIntersection(){
        if(!foundTarget){
            List<Cop> copList = getIntersectingObjects(Cop.class);
            if(!copList.isEmpty() && copList!=null){
                
                for(int i =0;i<copList.size();i++){
                    Cop cop = (Cop)copList.get(i);
                    
                    if(!cop.isDead){
                        if(cop.getY()-this.getY()>0 && cop.getY()-this.getY()<AREA && cop.isDead==false){
                            getWorld().removeObject(this);
                            foundTarget = true;
                            cop.isDead = true;
                            cop.die();
                            break;
                        }else if(cop.getY()-this.getY()>= AREA){
                            getWorld().setPaintOrder(cop.getClass(), this.getClass());
                            
                        }else{
                            getWorld().setPaintOrder(this.getClass(), cop.getClass());
                        }
                    }
                }
            }
        }
    }
    /**
     * Check if intersects with a mat.
     */
    public void theMatIntersection(){
        if(!foundTarget){
            List<Mat> matList = getIntersectingObjects(Mat.class);
            if(!matList.isEmpty() && matList!=null){
                
                for(int i =0;i<matList.size();i++){
                    Mat mat = (Mat)matList.get(i);
                    
                    if(!mat.isDead){
                        if(mat.getY()-this.getY()>0 && mat.getY()-this.getY()<AREA && mat.isDead==false){
                            getWorld().removeObject(this);
                            foundTarget = true;
                            mat.isDead = true;
                            mat.die();
                            break;
                        }else if(mat.getY()-this.getY()>= AREA){
                            getWorld().setPaintOrder(mat.getClass(), this.getClass());
                        }else{
                            getWorld().setPaintOrder(this.getClass(), mat.getClass());
                        }
                    }
                }
            }
        }
    }
}
